% APRENDIZAJE AUTOMÁTICO (G. Pajares y J. M. de la Cruz, Eds.)
% Editorial: RA-MA
% Capítulo 11: Razonamiento Basado en Casos
% Autores: Ángela Ribeiro, Xavier P. Burgos Artizzu y Jesús M. Conesa Muñoz

% Filtrado de malas hierbas, método F2 (antiguo F3)
% Analysis of natural images processing for the extraction of agricultural
% elements. Image Vision Comput. 28(1): 138-149 (2010)
function BW2 = F2(A,percent)
A = imopen(A,[1 1 1 1;1 1 1 1;1 1 1 1;1 1 1 1]);

L = bwlabel(A);
stats = regionprops(L,'Area');
[f,c] = size(stats);
largest=0;
for i=1:f
    largest = max(largest, stats(i).Area);
end;
idx = find([stats.Area] >= largest*percent);
BW2 = ismember(L,idx);

se = strel('octagon',6);
BW2 = imdilate(BW2,se);